| The Gaudi Framework v32r1 (f65d50dc)

Public Types | Public Member Functions | List of all members
IAuditor Class Referenceabstract

The IAuditor is the interface implmented by the AlgAuditor base class. More...

`#include <GaudiKernel/IAuditor.h>`

Inheritance diagram for IAuditor:
[legend]
Collaboration diagram for IAuditor:
[legend]

## Public Types
enum | StandardEventType { Initialize, ReInitialize, Execute, BeginRun, EndRun, Finalize, Start, Stop, ReStart }
| Defines the standard (= used by the framework) auditable event types. More...
typedef std::string | CustomEventType
| Type used to allow users to specify a custom event to be audit. More...
typedef const CustomEventType & | CustomEventTypeRef
| Used in function calls for optimization purposes. More...
Public Types inherited from IInterface
enum | Status : StatusCode::code_t { Status::FAILURE = 0, Status::SUCCESS = 1, Status::NO_INTERFACE, Status::VERSMISMATCH, Status::LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...

## Public Member Functions
| DeclareInterfaceID (IAuditor, 3, 0)
| InterfaceID. More...
virtual void | before (StandardEventType, INamedInterface *)=0
| Audit the start of a standard "event". More...
virtual void | before (StandardEventType, const std::string &)=0
| Audit the start of a standard "event" for callers that do not implement INamedInterface. More...
virtual void | before (CustomEventTypeRef, INamedInterface *)=0
| Audit the start of a custom "event". More...
virtual void | before (CustomEventTypeRef, const std::string &)=0
| Audit the start of a custom "event" for callers that do not implement INamedInterface. More...
virtual void | after (StandardEventType, INamedInterface *, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a standard "event". More...
virtual void | after (StandardEventType, const std::string &, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a standard "event" for callers that do not implement INamedInterface. More...
virtual void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a custom "event". More...
virtual void | after (CustomEventTypeRef, const std::string &, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a custom "event" for callers that do not implement INamedInterface. More...
virtual bool | isEnabled () const =0
| Tell if the auditor is enabled or not. More...
virtual void | beforeInitialize (INamedInterface *)=0
virtual void | afterInitialize (INamedInterface *)=0
virtual void | beforeReinitialize (INamedInterface *)=0
virtual void | afterReinitialize (INamedInterface *)=0
virtual void | beforeExecute (INamedInterface *)=0
virtual void | afterExecute (INamedInterface *, const StatusCode &)=0
virtual void | beforeBeginRun (INamedInterface *)=0
virtual void | afterBeginRun (INamedInterface *)=0
virtual void | beforeEndRun (INamedInterface *)=0
virtual void | afterEndRun (INamedInterface *)=0
virtual void | beforeFinalize (INamedInterface *)=0
virtual void | afterFinalize (INamedInterface *)=0
virtual StatusCode | sysInitialize ()=0
| Used by AuditorSvc. More...
virtual StatusCode | sysFinalize ()=0
| Used by AuditorSvc. More...
Public Member Functions inherited from INamedInterface
| DeclareInterfaceID (INamedInterface, 1, 0)
| InterfaceID. More...
virtual const std::string & | name () const =0
| Retrieve the name of the instance. More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Additional Inherited Members
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...

## Detailed Description

The IAuditor is the interface implmented by the AlgAuditor base class.

Concrete auditors, derived from the AlgAuditor base class are controlled via this interface.

Author
  Marjorie Shapiro, LBNL
  Marco Clemencic marco.nosp@m..cle.nosp@m.menci.nosp@m.c@ce.nosp@m.rn.ch

Definition at line 18 of file IAuditor.h.

## Member Typedef Documentation

## ◆ CustomEventType

typedef std::string IAuditor::CustomEventType

Type used to allow users to specify a custom event to be audit.

Examples of custom events are callbacks (see patch #1725).

Definition at line 29 of file IAuditor.h.

## ◆ CustomEventTypeRef

typedef const CustomEventType& IAuditor::CustomEventTypeRef

Used in function calls for optimization purposes.

Definition at line 31 of file IAuditor.h.

## Member Enumeration Documentation

## ◆ StandardEventType

enum IAuditor::StandardEventType

Defines the standard (= used by the framework) auditable event types.

Enumerator
Initialize |
ReInitialize |
Execute |
BeginRun |
EndRun |
Finalize |
Start |
Stop |
ReStart |

Definition at line 24 of file IAuditor.h.

24 { Initialize, ReInitialize, Execute, BeginRun, EndRun, Finalize, Start, Stop, ReStart };
IAuditor::Start
Definition: IAuditor.h:24
IAuditor::BeginRun
Definition: IAuditor.h:24
IAuditor::Stop
Definition: IAuditor.h:24
IAuditor::ReInitialize
Definition: IAuditor.h:24
IAuditor::ReStart
Definition: IAuditor.h:24
IAuditor::Finalize
Definition: IAuditor.h:24
IAuditor::Initialize
Definition: IAuditor.h:24
IAuditor::Execute
Definition: IAuditor.h:24
IAuditor::EndRun
Definition: IAuditor.h:24

## Member Function Documentation

## ◆ after() [1/4]

virtual void IAuditor::after | ( | StandardEventType | ,
|  | INamedInterface * | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)`
| ) |  |
| pure virtual

Audit the end of a standard "event".

## ◆ after() [2/4]

virtual void IAuditor::after | ( | StandardEventType | ,
|  | const std::string & | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)`
| ) |  |
| pure virtual

Audit the end of a standard "event" for callers that do not implement INamedInterface.

## ◆ after() [3/4]

virtual void IAuditor::after | ( | CustomEventTypeRef | ,
|  | INamedInterface * | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)`
| ) |  |
| pure virtual

Audit the end of a custom "event".

## ◆ after() [4/4]

virtual void IAuditor::after | ( | CustomEventTypeRef | ,
|  | const std::string & | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)`
| ) |  |
| pure virtual

Audit the end of a custom "event" for callers that do not implement INamedInterface.

## ◆ afterBeginRun()

virtual void IAuditor::afterBeginRun | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use after

## ◆ afterEndRun()

virtual void IAuditor::afterEndRun | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use after

## ◆ afterExecute()

virtual void IAuditor::afterExecute | ( | INamedInterface * | ,
|  | const StatusCode & |
| ) |  |
| pure virtual

Deprecated:
  use after

## ◆ afterFinalize()

virtual void IAuditor::afterFinalize | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use after

## ◆ afterInitialize()

virtual void IAuditor::afterInitialize | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use after

## ◆ afterReinitialize()

virtual void IAuditor::afterReinitialize | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use after

## ◆ before() [1/4]

virtual void IAuditor::before | ( | StandardEventType | ,
|  | INamedInterface * |
| ) |  |
| pure virtual

Audit the start of a standard "event".

## ◆ before() [2/4]

virtual void IAuditor::before | ( | StandardEventType | ,
|  | const std::string & |
| ) |  |
| pure virtual

Audit the start of a standard "event" for callers that do not implement INamedInterface.

## ◆ before() [3/4]

virtual void IAuditor::before | ( | CustomEventTypeRef | ,
|  | INamedInterface * |
| ) |  |
| pure virtual

Audit the start of a custom "event".

## ◆ before() [4/4]

virtual void IAuditor::before | ( | CustomEventTypeRef | ,
|  | const std::string & |
| ) |  |
| pure virtual

Audit the start of a custom "event" for callers that do not implement INamedInterface.

## ◆ beforeBeginRun()

virtual void IAuditor::beforeBeginRun | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use before

## ◆ beforeEndRun()

virtual void IAuditor::beforeEndRun | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use before

## ◆ beforeExecute()

virtual void IAuditor::beforeExecute | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use before

## ◆ beforeFinalize()

virtual void IAuditor::beforeFinalize | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use before

## ◆ beforeInitialize()

virtual void IAuditor::beforeInitialize | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use before

## ◆ beforeReinitialize()

virtual void IAuditor::beforeReinitialize | ( | INamedInterface * |  | ) |
| pure virtual

Deprecated:
  use before

## ◆ DeclareInterfaceID()

IAuditor::DeclareInterfaceID | ( | IAuditor | ,
|  | 3 | ,
|  | 0 |
| ) |  |

InterfaceID.

## ◆ isEnabled()

virtual bool IAuditor::isEnabled | ( |  | ) | const
| pure virtual

Tell if the auditor is enabled or not.

## ◆ sysFinalize()

virtual StatusCode IAuditor::sysFinalize | ( |  | ) |
| pure virtual

Used by AuditorSvc.

## ◆ sysInitialize()

virtual StatusCode IAuditor::sysInitialize | ( |  | ) |
| pure virtual

Used by AuditorSvc.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/IAuditor.h